import{S as Po,i as Ao,s as jo,e as i,k as d,w as b,t as s,M as qo,c as l,d as t,m as _,a as p,x,h as n,b as m,G as a,g as f,y as k,q as E,o as P,B as A,v as To,L as Kt}from"../../chunks/vendor-hf-doc-builder.js";import{T as Do}from"../../chunks/Tip-hf-doc-builder.js";import{I as Be}from"../../chunks/IconCopyLink-hf-doc-builder.js";import{C as ue}from"../../chunks/CodeBlock-hf-doc-builder.js";import{F as Eo,M as Xt}from"../../chunks/Markdown-hf-doc-builder.js";function No(U){let r,c;return{c(){r=i("p"),c=s("The text-to-image fine-tuning script is experimental. It\u2019s easy to overfit and run into issues like catastrophic forgetting. We recommend you explore different hyperparameters to get the best results on your dataset.")},l(o){r=l(o,"P",{});var g=p(r);c=n(g,"The text-to-image fine-tuning script is experimental. It\u2019s easy to overfit and run into issues like catastrophic forgetting. We recommend you explore different hyperparameters to get the best results on your dataset."),g.forEach(t)},m(o,g){f(o,r,g),a(r,c)},d(o){o&&t(r)}}}function Io(U){let r,c,o,g,j,D,Z,ee,te,N,R,y,S,M,V,ae,H,J,B,q,he,z,K,L,Y,O,le,I,oe,X,pe,C,W,F;return N=new ue({props:{code:`export MODEL_NAME="CompVis/stable-diffusion-v1-4"
export dataset_name="lambdalabs/pokemon-blip-captions"

accelerate launch train_text_to_image.py \\
  --pretrained_model_name_or_path=$MODEL_NAME \\
  --dataset_name=$dataset_name \\
  --use_ema \\
  --resolution=512 --center_crop --random_flip \\
  --train_batch_size=1 \\
  --gradient_accumulation_steps=4 \\
  --gradient_checkpointing \\
  --mixed_precision="fp16" \\
  --max_train_steps=15000 \\
  --learning_rate=1e-05 \\
  --max_grad_norm=1 \\
  --lr_scheduler="constant" --lr_warmup_steps=0 \\
  --output_dir="sd-pokemon-model" `,highlighted:`<span class="hljs-built_in">export</span> MODEL_NAME=<span class="hljs-string">&quot;CompVis/stable-diffusion-v1-4&quot;</span>
<span class="hljs-built_in">export</span> dataset_name=<span class="hljs-string">&quot;lambdalabs/pokemon-blip-captions&quot;</span>

accelerate launch train_text_to_image.py \\
  --pretrained_model_name_or_path=<span class="hljs-variable">$MODEL_NAME</span> \\
  --dataset_name=<span class="hljs-variable">$dataset_name</span> \\
  --use_ema \\
  --resolution=512 --center_crop --random_flip \\
  --train_batch_size=1 \\
  --gradient_accumulation_steps=4 \\
  --gradient_checkpointing \\
  --mixed_precision=<span class="hljs-string">&quot;fp16&quot;</span> \\
  --max_train_steps=15000 \\
  --learning_rate=1e-05 \\
  --max_grad_norm=1 \\
  --lr_scheduler=<span class="hljs-string">&quot;constant&quot;</span> --lr_warmup_steps=0 \\
  --output_dir=<span class="hljs-string">&quot;sd-pokemon-model&quot;</span> `}}),W=new ue({props:{code:`export MODEL_NAME="CompVis/stable-diffusion-v1-4"
export TRAIN_DIR="path_to_your_dataset"
export OUTPUT_DIR="path_to_save_model"

accelerate launch train_text_to_image.py \\
  --pretrained_model_name_or_path=$MODEL_NAME \\
  --train_data_dir=$TRAIN_DIR \\
  --use_ema \\
  --resolution=512 --center_crop --random_flip \\
  --train_batch_size=1 \\
  --gradient_accumulation_steps=4 \\
  --gradient_checkpointing \\
  --mixed_precision="fp16" \\
  --max_train_steps=15000 \\
  --learning_rate=1e-05 \\
  --max_grad_norm=1 \\
  --lr_scheduler="constant" --lr_warmup_steps=0 \\
  --output_dir=\${OUTPUT_DIR}`,highlighted:`<span class="hljs-built_in">export</span> MODEL_NAME=<span class="hljs-string">&quot;CompVis/stable-diffusion-v1-4&quot;</span>
<span class="hljs-built_in">export</span> TRAIN_DIR=<span class="hljs-string">&quot;path_to_your_dataset&quot;</span>
<span class="hljs-built_in">export</span> OUTPUT_DIR=<span class="hljs-string">&quot;path_to_save_model&quot;</span>

accelerate launch train_text_to_image.py \\
  --pretrained_model_name_or_path=<span class="hljs-variable">$MODEL_NAME</span> \\
  --train_data_dir=<span class="hljs-variable">$TRAIN_DIR</span> \\
  --use_ema \\
  --resolution=512 --center_crop --random_flip \\
  --train_batch_size=1 \\
  --gradient_accumulation_steps=4 \\
  --gradient_checkpointing \\
  --mixed_precision=<span class="hljs-string">&quot;fp16&quot;</span> \\
  --max_train_steps=15000 \\
  --learning_rate=1e-05 \\
  --max_grad_norm=1 \\
  --lr_scheduler=<span class="hljs-string">&quot;constant&quot;</span> --lr_warmup_steps=0 \\
  --output_dir=<span class="hljs-variable">\${OUTPUT_DIR}</span>`}}),{c(){r=i("p"),c=s("Launch the "),o=i("a"),g=s("PyTorch training script"),j=s(" for a fine-tuning run on the "),D=i("a"),Z=s("Pok\xE9mon BLIP captions"),ee=s(" dataset like this:"),te=d(),b(N.$$.fragment),R=d(),y=i("p"),S=s("To finetune on your own dataset, prepare the dataset according to the format required by \u{1F917} "),M=i("a"),V=s("Datasets"),ae=s(". You can "),H=i("a"),J=s("upload your dataset to the Hub"),B=s(", or you can "),q=i("a"),he=s("prepare a local folder with your files"),z=s("."),K=d(),L=i("p"),Y=s("Modify the script if you want to use custom loading logic. We left pointers in the code in the appropriate places to help you. \u{1F917} The example script below shows how to finetune on a local dataset in "),O=i("code"),le=s("TRAIN_DIR"),I=s(" and where to save the model to in "),oe=i("code"),X=s("OUTPUT_DIR"),pe=s(":"),C=d(),b(W.$$.fragment),this.h()},l($){r=l($,"P",{});var w=p(r);c=n(w,"Launch the "),o=l(w,"A",{href:!0,rel:!0});var me=p(o);g=n(me,"PyTorch training script"),me.forEach(t),j=n(w," for a fine-tuning run on the "),D=l(w,"A",{href:!0,rel:!0});var Q=p(D);Z=n(Q,"Pok\xE9mon BLIP captions"),Q.forEach(t),ee=n(w," dataset like this:"),w.forEach(t),te=_($),x(N.$$.fragment,$),R=_($),y=l($,"P",{});var T=p(y);S=n(T,"To finetune on your own dataset, prepare the dataset according to the format required by \u{1F917} "),M=l(T,"A",{href:!0,rel:!0});var u=p(M);V=n(u,"Datasets"),u.forEach(t),ae=n(T,". You can "),H=l(T,"A",{href:!0,rel:!0});var v=p(H);J=n(v,"upload your dataset to the Hub"),v.forEach(t),B=n(T,", or you can "),q=l(T,"A",{href:!0,rel:!0});var re=p(q);he=n(re,"prepare a local folder with your files"),re.forEach(t),z=n(T,"."),T.forEach(t),K=_($),L=l($,"P",{});var se=p(L);Y=n(se,"Modify the script if you want to use custom loading logic. We left pointers in the code in the appropriate places to help you. \u{1F917} The example script below shows how to finetune on a local dataset in "),O=l(se,"CODE",{});var ne=p(O);le=n(ne,"TRAIN_DIR"),ne.forEach(t),I=n(se," and where to save the model to in "),oe=l(se,"CODE",{});var _e=p(oe);X=n(_e,"OUTPUT_DIR"),_e.forEach(t),pe=n(se,":"),se.forEach(t),C=_($),x(W.$$.fragment,$),this.h()},h(){m(o,"href","https://github.com/huggingface/diffusers/blob/main/examples/text_to_image/train_text_to_image.py"),m(o,"rel","nofollow"),m(D,"href","https://huggingface.co/datasets/lambdalabs/pokemon-blip-captions"),m(D,"rel","nofollow"),m(M,"href","https://huggingface.co/docs/datasets/index"),m(M,"rel","nofollow"),m(H,"href","https://huggingface.co/docs/datasets/image_dataset#upload-dataset-to-the-hub"),m(H,"rel","nofollow"),m(q,"href","https://huggingface.co/docs/datasets/image_dataset#imagefolder"),m(q,"rel","nofollow")},m($,w){f($,r,w),a(r,c),a(r,o),a(o,g),a(r,j),a(r,D),a(D,Z),a(r,ee),f($,te,w),k(N,$,w),f($,R,w),f($,y,w),a(y,S),a(y,M),a(M,V),a(y,ae),a(y,H),a(H,J),a(y,B),a(y,q),a(q,he),a(y,z),f($,K,w),f($,L,w),a(L,Y),a(L,O),a(O,le),a(L,I),a(L,oe),a(oe,X),a(L,pe),f($,C,w),k(W,$,w),F=!0},p:Kt,i($){F||(E(N.$$.fragment,$),E(W.$$.fragment,$),F=!0)},o($){P(N.$$.fragment,$),P(W.$$.fragment,$),F=!1},d($){$&&t(r),$&&t(te),A(N,$),$&&t(R),$&&t(y),$&&t(K),$&&t(L),$&&t(C),A(W,$)}}}function Mo(U){let r,c;return r=new Xt({props:{$$slots:{default:[Io]},$$scope:{ctx:U}}}),{c(){b(r.$$.fragment)},l(o){x(r.$$.fragment,o)},m(o,g){k(r,o,g),c=!0},p(o,g){const j={};g&2&&(j.$$scope={dirty:g,ctx:o}),r.$set(j)},i(o){c||(E(r.$$.fragment,o),c=!0)},o(o){P(r.$$.fragment,o),c=!1},d(o){A(r,o)}}}function Uo(U){let r,c,o,g,j,D,Z,ee,te,N,R,y,S,M,V,ae,H,J,B,q,he,z,K,L,Y,O,le,I,oe,X,pe,C,W,F,$,w,me,Q,T;return N=new ue({props:{code:"pip install -U -r requirements_flax.txt",highlighted:"pip install -U -r requirements_flax.txt"}}),J=new ue({props:{code:`export MODEL_NAME="runwayml/stable-diffusion-v1-5"
export dataset_name="lambdalabs/pokemon-blip-captions"

python train_text_to_image_flax.py \\
  --pretrained_model_name_or_path=$MODEL_NAME \\
  --dataset_name=$dataset_name \\
  --resolution=512 --center_crop --random_flip \\
  --train_batch_size=1 \\
  --max_train_steps=15000 \\
  --learning_rate=1e-05 \\
  --max_grad_norm=1 \\
  --output_dir="sd-pokemon-model" `,highlighted:`<span class="hljs-built_in">export</span> MODEL_NAME=<span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>
<span class="hljs-built_in">export</span> dataset_name=<span class="hljs-string">&quot;lambdalabs/pokemon-blip-captions&quot;</span>

python train_text_to_image_flax.py \\
  --pretrained_model_name_or_path=<span class="hljs-variable">$MODEL_NAME</span> \\
  --dataset_name=<span class="hljs-variable">$dataset_name</span> \\
  --resolution=512 --center_crop --random_flip \\
  --train_batch_size=1 \\
  --max_train_steps=15000 \\
  --learning_rate=1e-05 \\
  --max_grad_norm=1 \\
  --output_dir=<span class="hljs-string">&quot;sd-pokemon-model&quot;</span> `}}),Q=new ue({props:{code:`export MODEL_NAME="duongna/stable-diffusion-v1-4-flax"
export TRAIN_DIR="path_to_your_dataset"

python train_text_to_image_flax.py \\
  --pretrained_model_name_or_path=$MODEL_NAME \\
  --train_data_dir=$TRAIN_DIR \\
  --resolution=512 --center_crop --random_flip \\
  --train_batch_size=1 \\
  --mixed_precision="fp16" \\
  --max_train_steps=15000 \\
  --learning_rate=1e-05 \\
  --max_grad_norm=1 \\
  --output_dir="sd-pokemon-model"`,highlighted:`<span class="hljs-built_in">export</span> MODEL_NAME=<span class="hljs-string">&quot;duongna/stable-diffusion-v1-4-flax&quot;</span>
<span class="hljs-built_in">export</span> TRAIN_DIR=<span class="hljs-string">&quot;path_to_your_dataset&quot;</span>

python train_text_to_image_flax.py \\
  --pretrained_model_name_or_path=<span class="hljs-variable">$MODEL_NAME</span> \\
  --train_data_dir=<span class="hljs-variable">$TRAIN_DIR</span> \\
  --resolution=512 --center_crop --random_flip \\
  --train_batch_size=1 \\
  --mixed_precision=<span class="hljs-string">&quot;fp16&quot;</span> \\
  --max_train_steps=15000 \\
  --learning_rate=1e-05 \\
  --max_grad_norm=1 \\
  --output_dir=<span class="hljs-string">&quot;sd-pokemon-model&quot;</span>`}}),{c(){r=i("p"),c=s("With Flax, it\u2019s possible to train a Stable Diffusion model faster on TPUs and GPUs thanks to "),o=i("a"),g=s("@duongna211"),j=s(". This is very efficient on TPU hardware but works great on GPUs too. The Flax training script doesn\u2019t support features like gradient checkpointing or gradient accumulation yet, so you\u2019ll need a GPU with at least 30GB of memory or a TPU v3."),D=d(),Z=i("p"),ee=s("Before running the script, make sure you have the requirements installed:"),te=d(),b(N.$$.fragment),R=d(),y=i("p"),S=s("Now you can launch the "),M=i("a"),V=s("Flax training script"),ae=s(" like this:"),H=d(),b(J.$$.fragment),B=d(),q=i("p"),he=s("To finetune on your own dataset, prepare the dataset according to the format required by \u{1F917} "),z=i("a"),K=s("Datasets"),L=s(". You can "),Y=i("a"),O=s("upload your dataset to the Hub"),le=s(", or you can "),I=i("a"),oe=s("prepare a local folder with your files"),X=s("."),pe=d(),C=i("p"),W=s("Modify the script if you want to use custom loading logic. We left pointers in the code in the appropriate places to help you. \u{1F917} The example script below shows how to finetune on a local dataset in "),F=i("code"),$=s("TRAIN_DIR"),w=s(":"),me=d(),b(Q.$$.fragment),this.h()},l(u){r=l(u,"P",{});var v=p(r);c=n(v,"With Flax, it\u2019s possible to train a Stable Diffusion model faster on TPUs and GPUs thanks to "),o=l(v,"A",{href:!0,rel:!0});var re=p(o);g=n(re,"@duongna211"),re.forEach(t),j=n(v,". This is very efficient on TPU hardware but works great on GPUs too. The Flax training script doesn\u2019t support features like gradient checkpointing or gradient accumulation yet, so you\u2019ll need a GPU with at least 30GB of memory or a TPU v3."),v.forEach(t),D=_(u),Z=l(u,"P",{});var se=p(Z);ee=n(se,"Before running the script, make sure you have the requirements installed:"),se.forEach(t),te=_(u),x(N.$$.fragment,u),R=_(u),y=l(u,"P",{});var ne=p(y);S=n(ne,"Now you can launch the "),M=l(ne,"A",{href:!0,rel:!0});var _e=p(M);V=n(_e,"Flax training script"),_e.forEach(t),ae=n(ne," like this:"),ne.forEach(t),H=_(u),x(J.$$.fragment,u),B=_(u),q=l(u,"P",{});var ie=p(q);he=n(ie,"To finetune on your own dataset, prepare the dataset according to the format required by \u{1F917} "),z=l(ie,"A",{href:!0,rel:!0});var G=p(z);K=n(G,"Datasets"),G.forEach(t),L=n(ie,". You can "),Y=l(ie,"A",{href:!0,rel:!0});var ze=p(Y);O=n(ze,"upload your dataset to the Hub"),ze.forEach(t),le=n(ie,", or you can "),I=l(ie,"A",{href:!0,rel:!0});var be=p(I);oe=n(be,"prepare a local folder with your files"),be.forEach(t),X=n(ie,"."),ie.forEach(t),pe=_(u),C=l(u,"P",{});var xe=p(C);W=n(xe,"Modify the script if you want to use custom loading logic. We left pointers in the code in the appropriate places to help you. \u{1F917} The example script below shows how to finetune on a local dataset in "),F=l(xe,"CODE",{});var Ye=p(F);$=n(Ye,"TRAIN_DIR"),Ye.forEach(t),w=n(xe,":"),xe.forEach(t),me=_(u),x(Q.$$.fragment,u),this.h()},h(){m(o,"href","https://github.com/duongna21"),m(o,"rel","nofollow"),m(M,"href","https://github.com/huggingface/diffusers/blob/main/examples/text_to_image/train_text_to_image_flax.py"),m(M,"rel","nofollow"),m(z,"href","https://huggingface.co/docs/datasets/index"),m(z,"rel","nofollow"),m(Y,"href","https://huggingface.co/docs/datasets/image_dataset#upload-dataset-to-the-hub"),m(Y,"rel","nofollow"),m(I,"href","https://huggingface.co/docs/datasets/image_dataset#imagefolder"),m(I,"rel","nofollow")},m(u,v){f(u,r,v),a(r,c),a(r,o),a(o,g),a(r,j),f(u,D,v),f(u,Z,v),a(Z,ee),f(u,te,v),k(N,u,v),f(u,R,v),f(u,y,v),a(y,S),a(y,M),a(M,V),a(y,ae),f(u,H,v),k(J,u,v),f(u,B,v),f(u,q,v),a(q,he),a(q,z),a(z,K),a(q,L),a(q,Y),a(Y,O),a(q,le),a(q,I),a(I,oe),a(q,X),f(u,pe,v),f(u,C,v),a(C,W),a(C,F),a(F,$),a(C,w),f(u,me,v),k(Q,u,v),T=!0},p:Kt,i(u){T||(E(N.$$.fragment,u),E(J.$$.fragment,u),E(Q.$$.fragment,u),T=!0)},o(u){P(N.$$.fragment,u),P(J.$$.fragment,u),P(Q.$$.fragment,u),T=!1},d(u){u&&t(r),u&&t(D),u&&t(Z),u&&t(te),A(N,u),u&&t(R),u&&t(y),u&&t(H),A(J,u),u&&t(B),u&&t(q),u&&t(pe),u&&t(C),u&&t(me),A(Q,u)}}}function Ro(U){let r,c;return r=new Xt({props:{$$slots:{default:[Uo]},$$scope:{ctx:U}}}),{c(){b(r.$$.fragment)},l(o){x(r.$$.fragment,o)},m(o,g){k(r,o,g),c=!0},p(o,g){const j={};g&2&&(j.$$scope={dirty:g,ctx:o}),r.$set(j)},i(o){c||(E(r.$$.fragment,o),c=!0)},o(o){P(r.$$.fragment,o),c=!1},d(o){A(r,o)}}}function So(U){let r,c;return r=new ue({props:{code:`from diffusers import StableDiffusionPipeline

model_path = "path_to_saved_model"
pipe = StableDiffusionPipeline.from_pretrained(model_path, torch_dtype=torch.float16)
pipe.to("cuda")

image = pipe(prompt="yoda").images[0]
image.save("yoda-pokemon.png")`,highlighted:`<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> StableDiffusionPipeline

model_path = <span class="hljs-string">&quot;path_to_saved_model&quot;</span>
pipe = StableDiffusionPipeline.from_pretrained(model_path, torch_dtype=torch.float16)
pipe.to(<span class="hljs-string">&quot;cuda&quot;</span>)

image = pipe(prompt=<span class="hljs-string">&quot;yoda&quot;</span>).images[<span class="hljs-number">0</span>]
image.save(<span class="hljs-string">&quot;yoda-pokemon.png&quot;</span>)`}}),{c(){b(r.$$.fragment)},l(o){x(r.$$.fragment,o)},m(o,g){k(r,o,g),c=!0},p:Kt,i(o){c||(E(r.$$.fragment,o),c=!0)},o(o){P(r.$$.fragment,o),c=!1},d(o){A(r,o)}}}function Lo(U){let r,c;return r=new Xt({props:{$$slots:{default:[So]},$$scope:{ctx:U}}}),{c(){b(r.$$.fragment)},l(o){x(r.$$.fragment,o)},m(o,g){k(r,o,g),c=!0},p(o,g){const j={};g&2&&(j.$$scope={dirty:g,ctx:o}),r.$set(j)},i(o){c||(E(r.$$.fragment,o),c=!0)},o(o){P(r.$$.fragment,o),c=!1},d(o){A(r,o)}}}function Fo(U){let r,c;return r=new ue({props:{code:`import jax
import numpy as np
from flax.jax_utils import replicate
from flax.training.common_utils import shard
from diffusers import FlaxStableDiffusionPipeline

model_path = "path_to_saved_model"
pipe, params = FlaxStableDiffusionPipeline.from_pretrained(model_path, dtype=jax.numpy.bfloat16)

prompt = "yoda pokemon"
prng_seed = jax.random.PRNGKey(0)
num_inference_steps = 50

num_samples = jax.device_count()
prompt = num_samples * [prompt]
prompt_ids = pipeline.prepare_inputs(prompt)

# shard inputs and rng
params = replicate(params)
prng_seed = jax.random.split(prng_seed, jax.device_count())
prompt_ids = shard(prompt_ids)

images = pipeline(prompt_ids, params, prng_seed, num_inference_steps, jit=True).images
images = pipeline.numpy_to_pil(np.asarray(images.reshape((num_samples,) + images.shape[-3:])))
image.save("yoda-pokemon.png")`,highlighted:`<span class="hljs-keyword">import</span> jax
<span class="hljs-keyword">import</span> numpy <span class="hljs-keyword">as</span> np
<span class="hljs-keyword">from</span> flax.jax_utils <span class="hljs-keyword">import</span> replicate
<span class="hljs-keyword">from</span> flax.training.common_utils <span class="hljs-keyword">import</span> shard
<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> FlaxStableDiffusionPipeline

model_path = <span class="hljs-string">&quot;path_to_saved_model&quot;</span>
pipe, params = FlaxStableDiffusionPipeline.from_pretrained(model_path, dtype=jax.numpy.bfloat16)

prompt = <span class="hljs-string">&quot;yoda pokemon&quot;</span>
prng_seed = jax.random.PRNGKey(<span class="hljs-number">0</span>)
num_inference_steps = <span class="hljs-number">50</span>

num_samples = jax.device_count()
prompt = num_samples * [prompt]
prompt_ids = pipeline.prepare_inputs(prompt)

<span class="hljs-comment"># shard inputs and rng</span>
params = replicate(params)
prng_seed = jax.random.split(prng_seed, jax.device_count())
prompt_ids = shard(prompt_ids)

images = pipeline(prompt_ids, params, prng_seed, num_inference_steps, jit=<span class="hljs-literal">True</span>).images
images = pipeline.numpy_to_pil(np.asarray(images.reshape((num_samples,) + images.shape[-<span class="hljs-number">3</span>:])))
image.save(<span class="hljs-string">&quot;yoda-pokemon.png&quot;</span>)`}}),{c(){b(r.$$.fragment)},l(o){x(r.$$.fragment,o)},m(o,g){k(r,o,g),c=!0},p:Kt,i(o){c||(E(r.$$.fragment,o),c=!0)},o(o){P(r.$$.fragment,o),c=!1},d(o){A(r,o)}}}function Oo(U){let r,c;return r=new Xt({props:{$$slots:{default:[Fo]},$$scope:{ctx:U}}}),{c(){b(r.$$.fragment)},l(o){x(r.$$.fragment,o)},m(o,g){k(r,o,g),c=!0},p(o,g){const j={};g&2&&(j.$$scope={dirty:g,ctx:o}),r.$set(j)},i(o){c||(E(r.$$.fragment,o),c=!0)},o(o){P(r.$$.fragment,o),c=!1},d(o){A(r,o)}}}function Co(U){let r,c,o,g,j,D,Z,ee,te,N,R,y,S,M,V,ae,H,J,B,q,he,z,K,L,Y,O,le,I,oe,X,pe,C,W,F,$,w,me,Q,T,u,v,re,se,ne,_e,ie,G,ze,be,xe,Ye,at,Qt,Zt,ot,ea,ta,We,aa,oa,yt,ce,ra,Ve,sa,na,rt,ia,la,bt,Je,pa,xt,ge,ke,st,Ue,fa,nt,ua,kt,Ke,ha,Et,Re,Pt,$e,Ee,it,Se,ma,lt,ca,At,Xe,da,jt,Le,qt,fe,_a,pt,ga,$a,ft,va,wa,ut,ya,ba,Tt,Pe,xa,ht,ka,Ea,Dt,Fe,Nt,ve,Ae,mt,Oe,Pa,ct,Aa,It,je,Mt,we,qe,dt,Ce,ja,_t,qa,Ut,Te,Ta,Qe,Da,Na,Rt,ye,De,gt,Ge,Ia,$t,Ma,St,Ne,Ua,Ze,Ra,Sa,Lt,Ie,Ft;return D=new Be({}),R=new Do({props:{warning:!0,$$slots:{default:[No]},$$scope:{ctx:U}}}),O=new ue({props:{code:`pip install git+https://github.com/huggingface/diffusers.git
pip install -U -r requirements.txt`,highlighted:`pip install git+https://github.com/huggingface/diffusers.git
pip install -U -r requirements.txt`}}),F=new ue({props:{code:"accelerate config",highlighted:"accelerate config"}}),re=new Be({}),Ue=new Be({}),Re=new ue({props:{code:"  --push_to_hub",highlighted:"  --push_to_hub"}}),Se=new Be({}),Le=new ue({props:{code:"  --checkpointing_steps=500",highlighted:"  --checkpointing_steps=500"}}),Fe=new ue({props:{code:'  --resume_from_checkpoint="checkpoint-1500"',highlighted:'  --resume_from_checkpoint=<span class="hljs-string">&quot;checkpoint-1500&quot;</span>'}}),Oe=new Be({}),je=new Eo({props:{pytorch:!0,tensorflow:!1,jax:!0,$$slots:{jax:[Ro],pytorch:[Mo]},$$scope:{ctx:U}}}),Ce=new Be({}),Ge=new Be({}),Ie=new Eo({props:{pytorch:!0,tensorflow:!1,jax:!0,$$slots:{jax:[Oo],pytorch:[Lo]},$$scope:{ctx:U}}}),{c(){r=i("meta"),c=d(),o=i("h1"),g=i("a"),j=i("span"),b(D.$$.fragment),Z=d(),ee=i("span"),te=s("Text-to-image"),N=d(),b(R.$$.fragment),y=d(),S=i("p"),M=s("Text-to-image models like Stable Diffusion generate an image from a text prompt. This guide will show you how to finetune the "),V=i("a"),ae=i("code"),H=s("CompVis/stable-diffusion-v1-4"),J=s(" model on your own dataset with PyTorch and Flax. All the training scripts for text-to-image finetuning used in this guide can be found in this "),B=i("a"),q=s("repository"),he=s(" if you\u2019re interested in taking a closer look."),z=d(),K=i("p"),L=s("Before running the scripts, make sure to install the library\u2019s training dependencies:"),Y=d(),b(O.$$.fragment),le=d(),I=i("p"),oe=s("And initialize an "),X=i("a"),pe=s("\u{1F917} Accelerate"),C=s(" environment with:"),W=d(),b(F.$$.fragment),$=d(),w=i("p"),me=s("If you have already cloned the repo, then you won\u2019t need to go through these steps. Instead, you can pass the path to your local checkout to the training script and it will be loaded from there."),Q=d(),T=i("h2"),u=i("a"),v=i("span"),b(re.$$.fragment),se=d(),ne=i("span"),_e=s("Hardware requirements"),ie=d(),G=i("p"),ze=s("Using "),be=i("code"),xe=s("gradient_checkpointing"),Ye=s(" and "),at=i("code"),Qt=s("mixed_precision"),Zt=s(", it should be possible to finetune the model on a single 24GB GPU. For higher "),ot=i("code"),ea=s("batch_size"),ta=s("\u2019s and faster training, it\u2019s better to use GPUs with more than 30GB of GPU memory. You can also use JAX/Flax for fine-tuning on TPUs or GPUs, which will be covered "),We=i("a"),aa=s("below"),oa=s("."),yt=d(),ce=i("p"),ra=s("You can reduce your memory footprint even more by enabling memory efficient attention with xFormers. Make sure you have "),Ve=i("a"),sa=s("xFormers installed"),na=s(" and pass the "),rt=i("code"),ia=s("--enable_xformers_memory_efficient_attention"),la=s(" flag to the training script."),bt=d(),Je=i("p"),pa=s("xFormers is not available for Flax."),xt=d(),ge=i("h2"),ke=i("a"),st=i("span"),b(Ue.$$.fragment),fa=d(),nt=i("span"),ua=s("Upload model to Hub"),kt=d(),Ke=i("p"),ha=s("Store your model on the Hub by adding the following argument to the training script:"),Et=d(),b(Re.$$.fragment),Pt=d(),$e=i("h2"),Ee=i("a"),it=i("span"),b(Se.$$.fragment),ma=d(),lt=i("span"),ca=s("Save and load checkpoints"),At=d(),Xe=i("p"),da=s("It is a good idea to regularly save checkpoints in case anything happens during training. To save a checkpoint, pass the following argument to the training script:"),jt=d(),b(Le.$$.fragment),qt=d(),fe=i("p"),_a=s("Every 500 steps, the full training state is saved in a subfolder in the "),pt=i("code"),ga=s("output_dir"),$a=s(". The checkpoint has the format "),ft=i("code"),va=s("checkpoint-"),wa=s(" followed by the number of steps trained so far. For example, "),ut=i("code"),ya=s("checkpoint-1500"),ba=s(" is a checkpoint saved after 1500 training steps."),Tt=d(),Pe=i("p"),xa=s("To load a checkpoint to resume training, pass the argument "),ht=i("code"),ka=s("--resume_from_checkpoint"),Ea=s(" to the training script and specify the checkpoint you want to resume from. For example, the following argument resumes training from the checkpoint saved after 1500 training steps:"),Dt=d(),b(Fe.$$.fragment),Nt=d(),ve=i("h2"),Ae=i("a"),mt=i("span"),b(Oe.$$.fragment),Pa=d(),ct=i("span"),Aa=s("Fine-tuning"),It=d(),b(je.$$.fragment),Mt=d(),we=i("h2"),qe=i("a"),dt=i("span"),b(Ce.$$.fragment),ja=d(),_t=i("span"),qa=s("LoRA"),Ut=d(),Te=i("p"),Ta=s("You can also use Low-Rank Adaptation of Large Language Models (LoRA), a fine-tuning technique for accelerating training large models, for fine-tuning text-to-image models. For more details, take a look at the "),Qe=i("a"),Da=s("LoRA training"),Na=s(" guide."),Rt=d(),ye=i("h2"),De=i("a"),gt=i("span"),b(Ge.$$.fragment),Ia=d(),$t=i("span"),Ma=s("Inference"),St=d(),Ne=i("p"),Ua=s("Now you can load the fine-tuned model for inference by passing the model path or model name on the Hub to the "),Ze=i("a"),Ra=s("StableDiffusionPipeline"),Sa=s(":"),Lt=d(),b(Ie.$$.fragment),this.h()},l(e){const h=qo('[data-svelte="svelte-1phssyn"]',document.head);r=l(h,"META",{name:!0,content:!0}),h.forEach(t),c=_(e),o=l(e,"H1",{class:!0});var He=p(o);g=l(He,"A",{id:!0,class:!0,href:!0});var vt=p(g);j=l(vt,"SPAN",{});var wt=p(j);x(D.$$.fragment,wt),wt.forEach(t),vt.forEach(t),Z=_(He),ee=l(He,"SPAN",{});var La=p(ee);te=n(La,"Text-to-image"),La.forEach(t),He.forEach(t),N=_(e),x(R.$$.fragment,e),y=_(e),S=l(e,"P",{});var et=p(S);M=n(et,"Text-to-image models like Stable Diffusion generate an image from a text prompt. This guide will show you how to finetune the "),V=l(et,"A",{href:!0,rel:!0});var Fa=p(V);ae=l(Fa,"CODE",{});var Oa=p(ae);H=n(Oa,"CompVis/stable-diffusion-v1-4"),Oa.forEach(t),Fa.forEach(t),J=n(et," model on your own dataset with PyTorch and Flax. All the training scripts for text-to-image finetuning used in this guide can be found in this "),B=l(et,"A",{href:!0,rel:!0});var Ca=p(B);q=n(Ca,"repository"),Ca.forEach(t),he=n(et," if you\u2019re interested in taking a closer look."),et.forEach(t),z=_(e),K=l(e,"P",{});var Ga=p(K);L=n(Ga,"Before running the scripts, make sure to install the library\u2019s training dependencies:"),Ga.forEach(t),Y=_(e),x(O.$$.fragment,e),le=_(e),I=l(e,"P",{});var Ot=p(I);oe=n(Ot,"And initialize an "),X=l(Ot,"A",{href:!0,rel:!0});var Ha=p(X);pe=n(Ha,"\u{1F917} Accelerate"),Ha.forEach(t),C=n(Ot," environment with:"),Ot.forEach(t),W=_(e),x(F.$$.fragment,e),$=_(e),w=l(e,"P",{});var Ba=p(w);me=n(Ba,"If you have already cloned the repo, then you won\u2019t need to go through these steps. Instead, you can pass the path to your local checkout to the training script and it will be loaded from there."),Ba.forEach(t),Q=_(e),T=l(e,"H2",{class:!0});var Ct=p(T);u=l(Ct,"A",{id:!0,class:!0,href:!0});var za=p(u);v=l(za,"SPAN",{});var Ya=p(v);x(re.$$.fragment,Ya),Ya.forEach(t),za.forEach(t),se=_(Ct),ne=l(Ct,"SPAN",{});var Wa=p(ne);_e=n(Wa,"Hardware requirements"),Wa.forEach(t),Ct.forEach(t),ie=_(e),G=l(e,"P",{});var de=p(G);ze=n(de,"Using "),be=l(de,"CODE",{});var Va=p(be);xe=n(Va,"gradient_checkpointing"),Va.forEach(t),Ye=n(de," and "),at=l(de,"CODE",{});var Ja=p(at);Qt=n(Ja,"mixed_precision"),Ja.forEach(t),Zt=n(de,", it should be possible to finetune the model on a single 24GB GPU. For higher "),ot=l(de,"CODE",{});var Ka=p(ot);ea=n(Ka,"batch_size"),Ka.forEach(t),ta=n(de,"\u2019s and faster training, it\u2019s better to use GPUs with more than 30GB of GPU memory. You can also use JAX/Flax for fine-tuning on TPUs or GPUs, which will be covered "),We=l(de,"A",{href:!0});var Xa=p(We);aa=n(Xa,"below"),Xa.forEach(t),oa=n(de,"."),de.forEach(t),yt=_(e),ce=l(e,"P",{});var tt=p(ce);ra=n(tt,"You can reduce your memory footprint even more by enabling memory efficient attention with xFormers. Make sure you have "),Ve=l(tt,"A",{href:!0});var Qa=p(Ve);sa=n(Qa,"xFormers installed"),Qa.forEach(t),na=n(tt," and pass the "),rt=l(tt,"CODE",{});var Za=p(rt);ia=n(Za,"--enable_xformers_memory_efficient_attention"),Za.forEach(t),la=n(tt," flag to the training script."),tt.forEach(t),bt=_(e),Je=l(e,"P",{});var eo=p(Je);pa=n(eo,"xFormers is not available for Flax."),eo.forEach(t),xt=_(e),ge=l(e,"H2",{class:!0});var Gt=p(ge);ke=l(Gt,"A",{id:!0,class:!0,href:!0});var to=p(ke);st=l(to,"SPAN",{});var ao=p(st);x(Ue.$$.fragment,ao),ao.forEach(t),to.forEach(t),fa=_(Gt),nt=l(Gt,"SPAN",{});var oo=p(nt);ua=n(oo,"Upload model to Hub"),oo.forEach(t),Gt.forEach(t),kt=_(e),Ke=l(e,"P",{});var ro=p(Ke);ha=n(ro,"Store your model on the Hub by adding the following argument to the training script:"),ro.forEach(t),Et=_(e),x(Re.$$.fragment,e),Pt=_(e),$e=l(e,"H2",{class:!0});var Ht=p($e);Ee=l(Ht,"A",{id:!0,class:!0,href:!0});var so=p(Ee);it=l(so,"SPAN",{});var no=p(it);x(Se.$$.fragment,no),no.forEach(t),so.forEach(t),ma=_(Ht),lt=l(Ht,"SPAN",{});var io=p(lt);ca=n(io,"Save and load checkpoints"),io.forEach(t),Ht.forEach(t),At=_(e),Xe=l(e,"P",{});var lo=p(Xe);da=n(lo,"It is a good idea to regularly save checkpoints in case anything happens during training. To save a checkpoint, pass the following argument to the training script:"),lo.forEach(t),jt=_(e),x(Le.$$.fragment,e),qt=_(e),fe=l(e,"P",{});var Me=p(fe);_a=n(Me,"Every 500 steps, the full training state is saved in a subfolder in the "),pt=l(Me,"CODE",{});var po=p(pt);ga=n(po,"output_dir"),po.forEach(t),$a=n(Me,". The checkpoint has the format "),ft=l(Me,"CODE",{});var fo=p(ft);va=n(fo,"checkpoint-"),fo.forEach(t),wa=n(Me," followed by the number of steps trained so far. For example, "),ut=l(Me,"CODE",{});var uo=p(ut);ya=n(uo,"checkpoint-1500"),uo.forEach(t),ba=n(Me," is a checkpoint saved after 1500 training steps."),Me.forEach(t),Tt=_(e),Pe=l(e,"P",{});var Bt=p(Pe);xa=n(Bt,"To load a checkpoint to resume training, pass the argument "),ht=l(Bt,"CODE",{});var ho=p(ht);ka=n(ho,"--resume_from_checkpoint"),ho.forEach(t),Ea=n(Bt," to the training script and specify the checkpoint you want to resume from. For example, the following argument resumes training from the checkpoint saved after 1500 training steps:"),Bt.forEach(t),Dt=_(e),x(Fe.$$.fragment,e),Nt=_(e),ve=l(e,"H2",{class:!0});var zt=p(ve);Ae=l(zt,"A",{id:!0,class:!0,href:!0});var mo=p(Ae);mt=l(mo,"SPAN",{});var co=p(mt);x(Oe.$$.fragment,co),co.forEach(t),mo.forEach(t),Pa=_(zt),ct=l(zt,"SPAN",{});var _o=p(ct);Aa=n(_o,"Fine-tuning"),_o.forEach(t),zt.forEach(t),It=_(e),x(je.$$.fragment,e),Mt=_(e),we=l(e,"H2",{class:!0});var Yt=p(we);qe=l(Yt,"A",{id:!0,class:!0,href:!0});var go=p(qe);dt=l(go,"SPAN",{});var $o=p(dt);x(Ce.$$.fragment,$o),$o.forEach(t),go.forEach(t),ja=_(Yt),_t=l(Yt,"SPAN",{});var vo=p(_t);qa=n(vo,"LoRA"),vo.forEach(t),Yt.forEach(t),Ut=_(e),Te=l(e,"P",{});var Wt=p(Te);Ta=n(Wt,"You can also use Low-Rank Adaptation of Large Language Models (LoRA), a fine-tuning technique for accelerating training large models, for fine-tuning text-to-image models. For more details, take a look at the "),Qe=l(Wt,"A",{href:!0});var wo=p(Qe);Da=n(wo,"LoRA training"),wo.forEach(t),Na=n(Wt," guide."),Wt.forEach(t),Rt=_(e),ye=l(e,"H2",{class:!0});var Vt=p(ye);De=l(Vt,"A",{id:!0,class:!0,href:!0});var yo=p(De);gt=l(yo,"SPAN",{});var bo=p(gt);x(Ge.$$.fragment,bo),bo.forEach(t),yo.forEach(t),Ia=_(Vt),$t=l(Vt,"SPAN",{});var xo=p($t);Ma=n(xo,"Inference"),xo.forEach(t),Vt.forEach(t),St=_(e),Ne=l(e,"P",{});var Jt=p(Ne);Ua=n(Jt,"Now you can load the fine-tuned model for inference by passing the model path or model name on the Hub to the "),Ze=l(Jt,"A",{href:!0});var ko=p(Ze);Ra=n(ko,"StableDiffusionPipeline"),ko.forEach(t),Sa=n(Jt,":"),Jt.forEach(t),Lt=_(e),x(Ie.$$.fragment,e),this.h()},h(){m(r,"name","hf:doc:metadata"),m(r,"content",JSON.stringify(Go)),m(g,"id","texttoimage"),m(g,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),m(g,"href","#texttoimage"),m(o,"class","relative group"),m(V,"href","https://huggingface.co/CompVis/stable-diffusion-v1-4"),m(V,"rel","nofollow"),m(B,"href","https://github.com/huggingface/diffusers/tree/main/examples/text_to_image"),m(B,"rel","nofollow"),m(X,"href","https://github.com/huggingface/accelerate/"),m(X,"rel","nofollow"),m(u,"id","hardware-requirements"),m(u,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),m(u,"href","#hardware-requirements"),m(T,"class","relative group"),m(We,"href","#flax-jax-finetuning"),m(Ve,"href","./optimization/xformers"),m(ke,"id","upload-model-to-hub"),m(ke,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),m(ke,"href","#upload-model-to-hub"),m(ge,"class","relative group"),m(Ee,"id","save-and-load-checkpoints"),m(Ee,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),m(Ee,"href","#save-and-load-checkpoints"),m($e,"class","relative group"),m(Ae,"id","finetuning"),m(Ae,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),m(Ae,"href","#finetuning"),m(ve,"class","relative group"),m(qe,"id","lora"),m(qe,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),m(qe,"href","#lora"),m(we,"class","relative group"),m(Qe,"href","lora#text-to-image"),m(De,"id","inference"),m(De,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),m(De,"href","#inference"),m(ye,"class","relative group"),m(Ze,"href","/docs/diffusers/pr_2715/en/api/pipelines/stable_diffusion/text2img#diffusers.StableDiffusionPipeline")},m(e,h){a(document.head,r),f(e,c,h),f(e,o,h),a(o,g),a(g,j),k(D,j,null),a(o,Z),a(o,ee),a(ee,te),f(e,N,h),k(R,e,h),f(e,y,h),f(e,S,h),a(S,M),a(S,V),a(V,ae),a(ae,H),a(S,J),a(S,B),a(B,q),a(S,he),f(e,z,h),f(e,K,h),a(K,L),f(e,Y,h),k(O,e,h),f(e,le,h),f(e,I,h),a(I,oe),a(I,X),a(X,pe),a(I,C),f(e,W,h),k(F,e,h),f(e,$,h),f(e,w,h),a(w,me),f(e,Q,h),f(e,T,h),a(T,u),a(u,v),k(re,v,null),a(T,se),a(T,ne),a(ne,_e),f(e,ie,h),f(e,G,h),a(G,ze),a(G,be),a(be,xe),a(G,Ye),a(G,at),a(at,Qt),a(G,Zt),a(G,ot),a(ot,ea),a(G,ta),a(G,We),a(We,aa),a(G,oa),f(e,yt,h),f(e,ce,h),a(ce,ra),a(ce,Ve),a(Ve,sa),a(ce,na),a(ce,rt),a(rt,ia),a(ce,la),f(e,bt,h),f(e,Je,h),a(Je,pa),f(e,xt,h),f(e,ge,h),a(ge,ke),a(ke,st),k(Ue,st,null),a(ge,fa),a(ge,nt),a(nt,ua),f(e,kt,h),f(e,Ke,h),a(Ke,ha),f(e,Et,h),k(Re,e,h),f(e,Pt,h),f(e,$e,h),a($e,Ee),a(Ee,it),k(Se,it,null),a($e,ma),a($e,lt),a(lt,ca),f(e,At,h),f(e,Xe,h),a(Xe,da),f(e,jt,h),k(Le,e,h),f(e,qt,h),f(e,fe,h),a(fe,_a),a(fe,pt),a(pt,ga),a(fe,$a),a(fe,ft),a(ft,va),a(fe,wa),a(fe,ut),a(ut,ya),a(fe,ba),f(e,Tt,h),f(e,Pe,h),a(Pe,xa),a(Pe,ht),a(ht,ka),a(Pe,Ea),f(e,Dt,h),k(Fe,e,h),f(e,Nt,h),f(e,ve,h),a(ve,Ae),a(Ae,mt),k(Oe,mt,null),a(ve,Pa),a(ve,ct),a(ct,Aa),f(e,It,h),k(je,e,h),f(e,Mt,h),f(e,we,h),a(we,qe),a(qe,dt),k(Ce,dt,null),a(we,ja),a(we,_t),a(_t,qa),f(e,Ut,h),f(e,Te,h),a(Te,Ta),a(Te,Qe),a(Qe,Da),a(Te,Na),f(e,Rt,h),f(e,ye,h),a(ye,De),a(De,gt),k(Ge,gt,null),a(ye,Ia),a(ye,$t),a($t,Ma),f(e,St,h),f(e,Ne,h),a(Ne,Ua),a(Ne,Ze),a(Ze,Ra),a(Ne,Sa),f(e,Lt,h),k(Ie,e,h),Ft=!0},p(e,[h]){const He={};h&2&&(He.$$scope={dirty:h,ctx:e}),R.$set(He);const vt={};h&2&&(vt.$$scope={dirty:h,ctx:e}),je.$set(vt);const wt={};h&2&&(wt.$$scope={dirty:h,ctx:e}),Ie.$set(wt)},i(e){Ft||(E(D.$$.fragment,e),E(R.$$.fragment,e),E(O.$$.fragment,e),E(F.$$.fragment,e),E(re.$$.fragment,e),E(Ue.$$.fragment,e),E(Re.$$.fragment,e),E(Se.$$.fragment,e),E(Le.$$.fragment,e),E(Fe.$$.fragment,e),E(Oe.$$.fragment,e),E(je.$$.fragment,e),E(Ce.$$.fragment,e),E(Ge.$$.fragment,e),E(Ie.$$.fragment,e),Ft=!0)},o(e){P(D.$$.fragment,e),P(R.$$.fragment,e),P(O.$$.fragment,e),P(F.$$.fragment,e),P(re.$$.fragment,e),P(Ue.$$.fragment,e),P(Re.$$.fragment,e),P(Se.$$.fragment,e),P(Le.$$.fragment,e),P(Fe.$$.fragment,e),P(Oe.$$.fragment,e),P(je.$$.fragment,e),P(Ce.$$.fragment,e),P(Ge.$$.fragment,e),P(Ie.$$.fragment,e),Ft=!1},d(e){t(r),e&&t(c),e&&t(o),A(D),e&&t(N),A(R,e),e&&t(y),e&&t(S),e&&t(z),e&&t(K),e&&t(Y),A(O,e),e&&t(le),e&&t(I),e&&t(W),A(F,e),e&&t($),e&&t(w),e&&t(Q),e&&t(T),A(re),e&&t(ie),e&&t(G),e&&t(yt),e&&t(ce),e&&t(bt),e&&t(Je),e&&t(xt),e&&t(ge),A(Ue),e&&t(kt),e&&t(Ke),e&&t(Et),A(Re,e),e&&t(Pt),e&&t($e),A(Se),e&&t(At),e&&t(Xe),e&&t(jt),A(Le,e),e&&t(qt),e&&t(fe),e&&t(Tt),e&&t(Pe),e&&t(Dt),A(Fe,e),e&&t(Nt),e&&t(ve),A(Oe),e&&t(It),A(je,e),e&&t(Mt),e&&t(we),A(Ce),e&&t(Ut),e&&t(Te),e&&t(Rt),e&&t(ye),A(Ge),e&&t(St),e&&t(Ne),e&&t(Lt),A(Ie,e)}}}const Go={local:"texttoimage",sections:[{local:"hardware-requirements",title:"Hardware requirements"},{local:"upload-model-to-hub",title:"Upload model to Hub"},{local:"save-and-load-checkpoints",title:"Save and load checkpoints"},{local:"finetuning",title:"Fine-tuning"},{local:"lora",title:"LoRA"},{local:"inference",title:"Inference"}],title:"Text-to-image"};function Ho(U){return To(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Jo extends Po{constructor(r){super();Ao(this,r,Ho,Co,jo,{})}}export{Jo as default,Go as metadata};
